<template>
  <div id="options-tab-content">
    <b-container>
      <p class="h2 pb-2">{{ $t(`${GLOBALS.__T_PREFIX__}.tabs.options`) | capitalize }}</p>
      <b-row>
        <b-col>
          <p>
            <ms-button
              text-align="left"
              @click.native="showCreateCategoryModal = !showCreateCategoryModal"
              inline
            >
              <v-icon name="plus" scale="0.6"></v-icon>
              {{ $t(`${GLOBALS.__T_PREFIX__}.global.newCategory`) | capitalize }}
            </ms-button>
            <ms-button
              v-if="categories.length > 0"
              text-align="left"
              @click.native="showAddSourceModal = !showAddSourceModal"
              inline
            >
              <v-icon name="plus" scale="0.6"></v-icon>
              {{ $t(`${GLOBALS.__T_PREFIX__}.global.addSource`) | capitalize }}
            </ms-button>
          </p>
          <p>{{ $t(`${GLOBALS.__T_PREFIX__}.global.createdCategories`) | capitalize }}</p>
          <ul class="list-unstyled created-categories-list">
            <li v-for="category in categories" :key="category.id" class="mb-1">
              <v-icon name="bookmark" :color="category.color"></v-icon>
              <span class="ml-2"><strong>{{ category.label }}</strong></span>
              <p class="edit-button" @click="editCategory(category)">
                <v-icon name="edit"></v-icon>
                <span>{{ $t(`${GLOBALS.__T_PREFIX__}.global.edit`) | capitalize }}</span>
              </p>
              <p class="list-sources-button" @click="listCategorySources(category)">
                <v-icon name="link"></v-icon>
                <span>{{ $t(`${GLOBALS.__T_PREFIX__}.global.feeds`) | capitalize }}</span>
              </p>
              <p class="delete-button" @click="handleDelete(category)">
                <v-icon name="times-circle"></v-icon>
                <span>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.editCategory.deleteCategory`) | capitalize }}</span>
              </p>
            </li>
          </ul>
        </b-col>
      </b-row>
      <add-source-modal
        :v-model="showAddSourceModal"
        @ok="showAddSourceModal = false"
        @cancel="showAddSourceModal = false"
      />
      <list-category-sources-modal
        :v-model="showListCategorySourcesModal"
        :category="categoryToEdit"
        @ok="showListCategorySourcesModal = false"
      />
      <create-category-modal
        :v-model="showCreateCategoryModal"
        @ok="showCreateCategoryModal = false"
        @cancel="showCreateCategoryModal = false"
      />
      <edit-category-modal
        :v-model="showEditCategoryModal"
        :category="categoryToEdit"
        @ok="showEditCategoryModal = false"
        @cancel="showEditCategoryModal = false"
      />
      <!-- Confirm deleting modal -->
      <ms-modal
        :v-model="showConfirmDeleting"
        :id="GLOBALS.__APP_NAME__ + '-delete-category-modal'"
        :ok="deleteCategory"
        :ok-title="$h.capitalize($t(`global.confirm`))"
        :cancel="cancelDelete"
        :cancel-title="$h.capitalize($t(`global.cancel`))"
      >
        <i18n :path="`${GLOBALS.__T_PREFIX__}.modals.deleteCategory.confirmDeleteMessage`" tag="p">
          <!-- ref: {0} -->
          <br/>
        </i18n>
      </ms-modal>
    </b-container>
  </div>
</template>

<script>
import { BaseComponent } from '@/utils/'

import AddSourceModal from '@/components/elements/modals/AddSourceModal'
import CreateCategoryModal from '@/components/elements/modals/CreateCategoryModal'
import ListCategorySourcesModal from '@/components/elements/modals/ListCategorySourcesModal'
import EditCategoryModal from '@/components/elements/modals/EditCategoryModal'

export default {
  extends: BaseComponent,
  components: {
    AddSourceModal,
    CreateCategoryModal,
    EditCategoryModal,
    ListCategorySourcesModal
  },
  data () {
    return {
      showCreateCategoryModal: false,
      showEditCategoryModal: false,
      showAddSourceModal: false,
      showListCategorySourcesModal: false,
      showConfirmDeleting: false,
      categoryToEdit: null
    }
  },
  state: {
    MyFeedsModule: [
      'feeds',
      'categories'
    ]
  },
  actions: {
    MyFeedsModule: [
      'loadCategories',
      'deleteCategories'
    ]
  },
  mutations: {
    MyFeedsModule: [
      'SET_FEEDS'
    ]
  },
  methods: {
    editCategory: function (category) {
      this.categoryToEdit = category
      this.showEditCategoryModal = true
    },
    listCategorySources: function (category) {
      this.categoryToEdit = category
      this.showListCategorySourcesModal = true
    },
    handleDelete: function (category) {
      this.categoryToEdit = category
      this.showConfirmDeleting = true
    },
    cancelDelete: function () {
      this.showConfirmDeleting = false
    },
    deleteCategory: async function () {
      this.showConfirmDeleting = false
      // Try to delete category
      const categoryId = this.categoryToEdit.id
      const deleteResponse = await this.deleteCategories(this.categoryToEdit)
      // If success
      if (!(deleteResponse instanceof Error)) {
        // Reload categories
        await this.loadCategories()
        // Clean feeds for deleted category
        const cleanedFeeds = this.feeds.reduce((array, feed) => {
          if (feed.category_id !== categoryId) {
            array.push(feed)
          }
          return array
        }, [])
        this.SET_FEEDS(cleanedFeeds)
      }
      return true
    }
  }
}
</script>
